.bp
.he 'BOOT (cmd)'TROPIX: Manual de Referncia'BOOT (cmd)'
.fo 'Atualizado em 29.08.06'Verso 4.9.0'Pag. %'

.b NOME
.in 5
Carga do sistema operacional:
.sp
.wo "boot0 -"
Estgio inicial
.br
.wo "boot1 -"
Estgio intermedirio
.br
.wo "boot2 -"
Estgio final
.br

.in
.sp
.b SINTAXE
.in 5
.(l
boot1:      > [-sSvV] [<boot2>]

boot2:  boot> [-x] [-v] [-<dev>] [<pgm>]
        boot>  -?  [-v]
.)l

.in
.sp
.b DESCRIO
.in 5
O processo de carga do sistema operacional TROPIX  composto de
4 etapas: BIOS (em ROM), "boot0", "boot1" e "boot2".

.sp
O "boot0" e "boot1" operam ainda no modo de 16 bits, utilizando as chamadas
"INT 13" da BIOS para realizar a leitura dos blocos dos discos.
.bc	/*************************************/
O "boot0" tenta, automaticamente, utilizar as extenses da INT 13, e
h duas verses para o "boot1": "lboot1" (usando) e "hboot1" (sem usar)
as extenses da INT 13. Se a BIOS do seu computador suportar estas
extenses, voc poder carregar sistemas operacionais (pelo menos o TROPIX)
em parties acima do limite de 8 GB (nmeros de cilindro maiores do que 1024).
.ec	/*************************************/

.sp
Na ltima fase de "boot", "boot2" o modo  passado para 32 bits, quando
ento a entrada/sada passa a ser realizada atravs de "drivers" includos
em "boot2". No momento, "boot2" contm "drivers" para disquete, discos IDE e
os controladores de discos SCSI Adaptec ISA 1542 e PCI 2940/29160.

.sp
Os diversos programas de "boot" tentam fornecer para a
etapa seguinte qual foi o dispositivo do qual foram lidos.
O objetivo consiste em escolher um dispositivo durante a segunda etapa
("boot0"), e este mesmo dispositivo ser usado para a leitura de "boot1",
"boot2", o ncleo do TROPIX e finalmente ser usado como sistema de arquivos
"raiz" do sistema operacional.

.sp
Repare que, a partir da verso 4.3.0, h dois tipos de sistemas de arquivos
nativos do TROPIX: o "antigo" (V7) com blocos de 512 bytes (em obsolescncia)
e o "novo" (T1) com blocos de 4 KB.

.sp
A descrio do processo de "boot" dada abaixo refere-se  carga atravs de
disco rgido. Se for dado "boot" em um disquete com um sistema de arquivos
TROPIX (V7 ou T1), este conter no primeiro bloco (de 512 bytes ou 4 KB)
o "boot1" (no havendo o "boot0").

.in
.sp
.b BIOS
.in 5
A BIOS do PC (aps diversos testes e inicializaes), le o primeiro
bloco (de 512 bytes) de um disco ("/dev/hda" ou "/dev/sda") para a memria,
e passa o controle para o programa contido neste bloco.

.in
.sp
.b BOOT0
.in 5
Este primeiro bloco contm o incio de "boot0", que por sua vez
le os seus blocos restantes do mesmo disco.
O "boot0" imprime uma tabela com as parties ativas dos diversos
discos encontrados no sistema, e pede o ndice da partio desejada
para prosseguir o procedimento de carga.

.sp
So impressos tambm o ndice "default" (valor por omisso), e o nmero
de segundos remanescentes at que seja carregada
(se nada for teclado)
a partio indicada pelo ndice "default".
Este ndice "default" pode ser alterado atravs de "edboot" (cmd).
Repare que, se o ndice "default" for NULO, ele ser substitudo pela primeira
partio de tipo TROPIX (V7 ou T1) da tabela.

.sp
O "boot0" permite carregar diversos sistemas operacionais,
e j foi testado com MS-DOS/Win3.1/Win95/Win98/WinNT/Win2000, Linux
e FreeBSD (alm, naturalmente, do TROPIX).

.sp
Dependendo do ndice escohido, iremos carregar o TROPIX ou um
outro sistema operacional.
Se for escolhida a continuao da carga do TROPIX, o "boot0" carrega
o "boot1", contido no incio da partio ativa escolhida.

.in
.sp
.(t
.b BOOT1
.in 5
O "boot1", por sua vez, aguarda que seja teclado o nome do arquivo
que contm o "boot2" (normalmente "/boot", que  o valor "default"
usado se for teclado <enter>).

.sp
Normalmente, o modo de vdeo usado a partir de "boot2"  o "svga"
(113 colunas e 48 linhas, 1024x768).
Isto pode ser modificado para todas as cargas do sistema atravs
de "edboot" (cmd), ou apenas para esta carga atravs de uma das opes do "boot1":
"-v" ou "-V" para o modo "vga" (80 colunas e 24 linhas, 720x400) e
"-s" ou "-S" para o modo "svga"

.sp
Durante a carga, se o controlador de vdeo no possibilitar o modo
"svga", automaticamente ser usado o "vga".

.sp
Em seguida, "boot1" le o "boot2" e passa o controle para ele.
.)t

.in
.sp
.b BOOT2
.in 5
A ltima etapa, o "boot2", permite carregar o arquivo contendo o ncleo 
do TROPIX, editar as tabelas de parties, alm de outras funes.
Vrios comandos de "boot2" iniciam dilogos, pedindo informaes sobre
o comando a ser executado. Neste caso, a qualquer momento, o comando pode
ser cancelado atravs de uma resposta "n".

.bc	/*************************************/
A ltima etapa, o "boot2", permite escolher o nome do programa que
contm o ncleo do TROPIX (normalmente "/tropix")
e tambm o dispositivo no qual ele deve ser procurado (normalmente a primeira
partio de tipo TROPIX encontrado durante a anlise das vrias parties
dos diversos discos). 
Tanto o nome do programa como o dispositivo "default" podem ser alterados
atravs de "edboot" (cmd).
.ec	/*************************************/

.in
.sp
.b "EXTENSES da INT 13"
.in 5
O "boot0" tenta, automaticamente, utilizar as extenses da INT 13, e
para discos rgidos, h ao total 4 verses do "boot1" (veja a lista abaixo).
.sp
Se a BIOS do seu computador suportar estas
extenses, voc poder carregar sistemas operacionais (pelo menos o TROPIX)
em parties acima do limite de 8 GB (nmeros de cilindro maiores do que 1024).

.in
.sp
.b 'COMANDOS de "BOOT2"'
.in 5
Os comandos aceitos por "boot2" so:

.in +3
.ip "[-x] [-<dev>] [<pgm>]" 3
.sp
Carrega (e executa) <pgm> (normalmente um ncleo do TROPIX),
contido no dispositivo <dev>.
Tanto <dev> como <pgm> tem valores "defaults", que podem ser alterados
atravs de "edboot" (cmd). Se no foram alterados, estes valores
"default" so "a partio usada por boot1" e "/tropix".
.bc	/*************************************/
"a primeira partio de tipo TROPIX encontrada" e "/tropix".
.ec	/*************************************/

.sp
Aps a carga de <pgm> (e antes de sua execuo) ainda  pedida uma
confirmao para a execuo. No caso de uma resposta negativa, o
"boot2" retm o controle, e pode ser executada qualquer uma das funes
aqui descritas (inclusive, por exemplo, carregar outro <pgm>.

.ip -t 3
Imprime a tabela de parties em uso, com uma linha por partio.
A tabela contm as seguintes colunas:

.in +5
.ip 1. 3
O nome da partio. Durante o funcionamento do TROPIX, cada partio  associada a
um dispositivo com o prefixo "/dev/" anteposto ao nome da partio.
Assim, por exemplo, a partio de nome "hda1" corresponder ao dispositivo
"/dev/hda1".

.ip 2. 3
Um asterisco se a partio est "ativa", isto , se  possvel carregar
um sistema operacional desta partio. Durante o processo de "boot", o
estgio inicial "boot0" s considera parties "ativas".

.ip 3. 3
Nmero do bloco (de 512 bytes) inicial da partio.

.ip 4. 3
Tamanho da partio em blocos.

.ip 5. 3
Tamanho da partio em MB.

.ip 6. 3
Cdigo numrico do dispositivo associado  partio. Este cdigo  composto
de duas partes chamadas de "major" e "minor".

.ip 7. 3
Nmero da unidade e alvo fsicos do dispositivo.

.ip 8. 3
Nome simblico do tipo da partio.

.ep
.in -5

.ip -f 3
Executa o editor de tabelas de parties "fdisk" (cmd).

.bc	/*************************************/
.ip -l 3
Imprime o contedo de um diretrio.
O nome do dispositivo e o nome do diretrio so pedidos atravs de um
dilogo.
.ec	/*************************************/

.ip -d 3
Imprime uma listagem em hexadecimal e caracteres de um dispositivo.
O nome do dispositivo e o endereo inicial so pedidos atravs de um
dilogo.

.ip -m 3
Imprime uma listagem em hexadecimal e caracteres da memria.
O endereo inicial  pedido atravs de um dilogo.

.ip "-r [-<dev>] [<arq>]" 3
.sp
Descompata  <arq> (normalmente a imagem comprimida de um sistema de arquivos
T1 contendo uma RAIZ), contido no dispositivo <dev> para uma rea de RAMD.
O dispositivo <dev> tem um valor "default", que  "a partio usada por
"boot1", mas pode ser alterado atravs de "edboot" (cmd).
O valor "default" de <arq>  "boot.dsk.gz".

.sp
Aps esta carga, deve-se utilizar o comando "-x" com o dispositivo "ramd0",
para executar o ncleo do TROPIX, com a RAIZ no RAMD.

.ip -i 3
Inicia uma instalao ou conserto de sistemas de arquivos.
 equivalente a "-r -fd0 boot.dsk.gz" seguido de "-x -ramd0 tropix".
Isto decompacta uma imagem comprimida de uma RAIZ de um disquete
para o RAMD, e em seguida executa o TROPIX, com a RAIZ no RAMD.


.bc	/*************************************/
.ip -c 3
Copia um dispositivo ou arquivo regular para um dispositivo.
A cpia  feita inicialmente para a memria, e desta para o dispositivo de
sada.
O nome do dispositivo/arquivo de entrada, deslocamento da entrada,
nome do dispositivo de sada, deslocamento da sada
e o nmero de blocos a copiar so pedidos atravs
de um dilogo.

.ip -r 3
Copia um dispositivo para uma rea de RAMD.
O nome do dispositivo de entrada  pedido atravs de um
dilogo (se no for dado,  usado "fd0"). 
 copiado a imagem inteira do dispositivo no final da memria fsica.
.ec	/*************************************/

.ip -s 3
Reavalia a velocidade da CPU.
Com isto, so recalculados a freqncia da CPU (MHz) e o valor
adequado para DELAY (a funo que permite esperas a nvel de microsegundos).
Ao final, so impressas 10 mensagens com intervalos de um segundo,
para verificar se o valor de DELAY est correto.

.bc	/*************************************/
.ip -p 3
Imprime os parmetros dos discos IDE.
So impressos a geometria real e a utilizada pela BIOS dos discos IDE
(Esta ltima apenas para os discos do primeiro controlador).
.ec	/*************************************/

.ip -v 3
Verboso.

.ip -? 3
Imprime um resumo dos comandos.

.ep
.in -3

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
edboot, fdisk
.br
.wo "(ref): "
install
.br

.in
.sp
.b ARQUIVOS
.in 5
.(l
/etc/boot/d.boot0		Para testar, em disquete
/etc/boot/h.boot0		Para disco rgido
/etc/boot/t1.d.boot1	Disquete 1.44 MB, T1
/etc/boot/t1.g.boot1	Disco rgido, sem as extenses, T1
/etc/boot/t1.l.boot1	Disco rgido, com as extenses, T1
/etc/boot/cd.boot1		Disco compacto (CD)
/etc/boot/v7.d.boot1	Disquete 1.44 MB, V7
/etc/boot/v7.g.boot1	Disco rgido, sem as extenses, V7
/etc/boot/v7.l.boot1	Disco rgido, com as extenses, V7
/boot			Verso nica de "boot2"
.)l

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
