/*
 ****************************************************************
 *								*
 *			<sys/ipc.h>				*
 *								*
 *	Tabelas de eventos e semforos do usurio		*
 *								*
 *	Verso	3.0.0, de 07.09.94				*
 *		3.0.0, de 07.09.94				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *		/usr/include/sys				*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  1999 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

#define	IPC_H			/* Para definir os prottipos */

/*
 ******	Formato das estruturas **********************************
 */
struct	ueventl
{
	UEVENTG	*uel_uevent;	/* Ponteiro para o evento global */
};

struct	ueventg
{
	EVENT	ueg_event;	/* Evento propriamente dito */
	char	ueg_reser;
	short	ueg_eventid;	/* Identificao do evento */
	long	ueg_count;	/* Contador de ocorrncias */
	UEVENTG	*ueg_next;	/* Prximo evento associado */
};

struct	usemal
{
	USEMAG	*usl_usema;	/* Ponteiro para o semforo global */
	short	usl_count;	/* Contador de recursos alocados */
	short	usl_reser;
};

struct	usemag
{
	SEMA	usg_sema;	/* Semforo propriamente dito */
	short	usg_semaid;	/* Identificao do semforo */
	short	usg_reser;
	USEMAG	*usg_next;	/* Prximo semforo associado */
};

/*
 ******	Modos de ao do "ueventctl" e "usemactl" ***************
 */
typedef enum
{
	UE_ALLOC,	/* Aloca UEVENTLs */
	UE_GET		/* Obtm o descritor de um UEVENTL*/

}	UEVENTCTLFUNC;

typedef enum
{
	US_ALLOC,	/* Aloca USEMALs */
	US_GET,		/* Obtm o descritor de um USEMAL */
	US_AVAIL,	/* No. de recursos ainda disponveis */
	US_WAIT		/* No. de threads/procs esperando pelo sem. */

}	USEMACTLFUNC;
