/*
 ****************************************************************
 *								*
 *			<sys/kcntl.h>				*
 *								*
 *	Controle do Kernel					*
 *								*
 *	Verso	1.0.0, de 02.02.87				*
 *		4.5.0, de 01.10.03				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *		/usr/include/sys				*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 * 		Copyright  2003 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#define	KCNTL_H			/* Para definir os prottipos */

/*
 ****************************************************************
 *	Comandos do KCNTL					*
 ****************************************************************
 */
typedef enum
{
	K_GETSYMGN = 1,		/* Obtem um SYM dado o nome */
	K_GETSYMGA,		/* Obtem um SYM dado o endereco */
	K_GETDEV,		/* Obtem o dev (MAJOR+MINOR) dado o devname */
	K_GETDEVNM,		/* Obtem o devname dado o dev (MAJOR+MINOR) */
	K_PUTCVTB,		/* Modifica a Tabela de converso */
	K_SEMAFREE,		/* Libera o recurso de um processo */
	K_GETPSZ,		/* Obtm os tamanhos das reas do processo */
	K_KTRACE,		/* Gera um trace dos recursos usados */
	K_GETMMU,		/* Obtem informaes da gerencia de memria */
	K_SETPREEMPTION,	/* Habilita preemption no kernel */
	K_ERRTOSTR,		/* Obtm uma cadeia com o nome do erro */
	K_GET_DEV_TB,		/* Obtm uma entrada da tabela de discos */
	K_GET_PARTNM,		/* Obtm o nome de um tipo de partio */
	K_GET_FD_TYPE,		/* Obtm os tipos dos disquetes */
	K_MMU_LIMIT,		/* Obtm/atribui o limite da MMU */
	K_DEBUG,		/* Obtm/atribui o valor de DEBUG */
	K_CR0,			/* Obtm/atribui o valor de "cr0" */
	K_DMESG,		/* Obtm as mensagens do "boot" */

}	KENUM;

/*
 ******	Estrutura para "K_GETPSZ" *******************************
 */
typedef struct
{
	long	k_tsize;	/* Tamanho do texto do processo (bytes) */
	long	k_dsize;	/* Tamanho do data+bss do processo (bytes) */
	long	k_ssize;	/* Tamanho da pilha do processo (bytes) */
	long	k_res0[5];	/* Reservado para uso futuro */

}	KPSZ;

/*
 ******	Definies para "K_KTRACE" ******************************
 */
#define	PROCSWTIME	1	/* Tempo para troca de processo */
#define	CLKINTTIME	2	/* Tempo para atend. int. relgio */

/*
 ****** Tabela de tipos de sistemas de arquivos *****************
 */
typedef struct
{
	int	pt_type;	/* Tipo do sistema de arquivos */
	char	*pt_nm;		/* Nome do sistema de arquivos */

}	PARTNM;

#define	PARTNM_MAXSZ	20	/* Nenhum nome tem mais de 20 caracteres */
