/*
 ****************************************************************
 *								*
 *			<sys/mntent.h>				*
 *								*
 *	Parmetros de montagem de systemas de arquivos		*
 *								*
 *	Verso	4.8.0, de 27.09.05				*
 *		4.8.0, de 27.09.05				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *		/usr/include/sys				*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2005 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

#define	MNTENT_H		/* Para definir os prottipos */

/*
 ****** Estrutura com as opes de montagem *********************
 */
struct mntent
{
	int	me_flags;		/* Indicadores: veja abaixo */
	int	me_uid, me_gid;		/* Usurio e Grupo */

	/* Vrios parmetros para NFS */

	long	me_server_addr;		/* Endereo IP do servidor */
	int	me_rsize;		/* Tamanho de leitura */
	int	me_wsize;		/* Tamanho de escrita */
	int	me_timeout;		/* Tempo para retransmisso */
	int	me_retrans;		/* No. de retransmisses */
	int	me_port;		/* No. da porta */
	int	me_nfsvers;		/* Verso do protocolo NFS */

	int	me_reser[6];		/* Reserva para 64 bytes */
};

/*
 ****** Os valores de "me_flags" ********************************
 */
enum
{
	SB_RONLY	= (1 <<  0),	/* O FS  READONLY */
	SB_USER		= (1 <<  1),	/* Pode ser montado por usurios regulares */
	SB_ATIME	= (1 <<  2),	/* Atualiza os tempos de acesso */ 
	SB_DEV		= (1 <<  3),	/* Interpreta os dispositivos */ 
	SB_EXEC		= (1 <<  4),	/* Executa programas */ 
	SB_SUID		= (1 <<  5),	/* Interpreta os indicadores SUID/SGID */ 
	SB_EJECT	= (1 <<  6),	/* Ejeta aps a desmontagem */ 
	SB_CASE		= (1 <<  7),	/* A "caixa alta/baixa" importa nos nomes */ 
	SB_ROCK		= (1 <<  8),	/* Usar a extenso "Rock Ridge", se presente */ 
	SB_JOLIET	= (1 <<  9),	/* Usar a extenso "Joliet", se presente */ 
	SB_LFN		= (1 << 10),	/* L/escreve com "long file names" */ 
	SB_HARD		= (1 << 11),	/* Montagem "soft/hard" para NFS */ 

	SB_AUTO		= (1 << 29),	/* Monta com "mount -a" */
	SB_FSCK		= (1 << 30)	/* Verifica o sistema de arquivos */

	/* No usar o bit 31 para evitar nmeros negativos */
};

/*
 ****** Os valores de "default" *********************************
 */
enum {	SB_DEFAULT_ON	= (SB_DEV|SB_EXEC|SB_SUID|SB_CASE|SB_ROCK|SB_JOLIET|SB_LFN|SB_AUTO) };

enum {	SB_NOT_KERNEL	= (SB_AUTO|SB_FSCK) };

enum {	SB_RSIZE = 1024, SB_WSIZE = 1024, SB_TIMEOUT = 1, SB_RETRANS = 8, SB_PORT = 2049, SB_NFSVERS = 2 };
