/*
 ****************************************************************
 *								*
 *			<sys/shlib.h>				*
 *								*
 *	Estrutura da tabela de bibliotecas compartilhadas	*
 *								*
 *	Verso	3.2.3, de 02.12.99				*
 *		4.3.0, de 12.06.02				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *		/usr/include/sys				*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2002 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

#define	SHLIB_H			/* Para definir os prottipos */

/*
 ******	Tabela de bibliotecas compartilhadas ********************
 */
typedef struct
{
	char	sh_name[16];	/* Nome da biblioteca */
	time_t	sh_time;	/* Data da biblioteca */

	ushort	sh_dep_mask;	/* Dependncias desta biblioteca */
	ushort	sh_hash_seq;	/* Ordem na insero HASH */

	long	sh_tsize;	/* Tamanho do TEXT */
	long	sh_dsize;	/* Tamanho do DATA */
	long	sh_bsize;	/* Tamanho do BSS */
	long	sh_ssize;	/* Tamanho da SYMTB */

	pg_t	sh_tvaddr;	/* Endereo virtual do TEXT */
	pg_t	sh_dvaddr;	/* Endereo virtual do DATA */

	ulong	sh_vaddr_mask;	/* Indica as pginas virtuais usadas */

	REGIONG	*sh_region;	/* Regio global do TEXT + DATA */

	/* Estatsticas */

	int	sh_sym_count;	/* No. de smbolos */
	int	sh_hash_col;	/* Colises HASH */

}	SHLIB;

#define NSHLIB	4	/* Nmero mximo de bibliotecas compartihadas */

#define NOSHLIB	(SHLIB *)NULL

extern SHLIB	shlib_tb[];

/*
 ******	Prottipos de funes ***********************************
 */
enum { SHLIB_LOAD, SHLIB_UNLOAD, SHLIB_TABLE };	/* As operaes */

extern int	shlib (int op, ...);
