/*
 ****************************************************************
 *								*
 *			<sys/uerror.h>				*
 *								*
 *	Cdigo dos erros do usurio				*
 *								*
 *	Verso	3.0.0, de 05.10.94				*
 *		4.8.0, de 23.10.05				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *		/usr/include/sys				*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2005 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

#define	UERROR_H		/* Para definir os prottipos */

/*
 ****************************************************************
 *	Cdigos de erros					*
 ****************************************************************
 */
typedef	enum
{
	/* 00: */ NOERR,		/* Erro ZERO */
	/* 01: */ EPERM,		/* No  o dono ou superusurio */
	/* 02: */ ENOENT,		/* Nome de arquivo desconhecido */
	/* 03: */ ESRCH,		/* Nmero de processo desconhecido */
	/* 04: */ EINTR,		/* Chamada ao sistema interrompida */
	/* 05: */ EIO,			/* Erro de entrada/sada */
	/* 06: */ ENXIO,		/* Dispositivo desconhecido ou endereo fora dos limites */
	/* 07: */ E2BIG,		/* Lista de argumentos longa demais */
	/* 08: */ ENOEXEC,		/* Arquivo no-executvel */
	/* 09: */ EBADF,		/* Descritor de arquivo invlido */
	/* 10: */ ECHILD,		/* O Processo no possui filhos */
	/* 11: */ EAGAIN,		/* Recurso no disponvel, tente mais tarde */
	/* 12: */ ENOMEM,		/* Memria insuficiente */
	/* 13: */ EACCES,		/* Permisso negada */
	/* 14: */ EFAULT,		/* Endereo invlido de memria */
	/* 15: */ ENOTBLK,		/* Este dispositivo no  de blocos */
	/* 16: */ EBUSY,		/* Recurso ocupado */
	/* 17: */ EEXIST,		/* O arquivo j existe */
	/* 18: */ EXDEV,		/* Elo atravs de sistema de arquivos */
	/* 19: */ ENODEV,		/* Dispositivo inexistente */
	/* 20: */ ENOTDIR,		/* No  um diretrio */
	/* 21: */ EISDIR,		/*  um diretrio */
	/* 22: */ EINVAL,		/* Argumento ou operao invlido */
	/* 23: */ ENFILE,		/* Tabela FILE cheia */
	/* 24: */ EMFILE,		/* Arquivos abertos demais */
	/* 25: */ ENOTTY,		/* O dispositivo no  de caracteres */
	/* 26: */ ETXTBSY,		/* Texto ocupado */
	/* 27: */ EFBIG,		/* Arquivo excessivamente grande */
	/* 28: */ ENOSPC,		/* Sistema de arquivos cheio */
	/* 29: */ ESPIPE,		/* \"Seek\" em PIPE ou FIFO */
	/* 30: */ EROFS, 		/* Proteo de escrita */
	/* 31: */ EMLINK,		/* Nmero excessivo de elos fsicos */
	/* 32: */ EPIPE,		/* PIPE sem leitor */
	/* 33: */ EDOM,			/* Argumento fora dos limites */
	/* 34: */ ERANGE,		/* Resultado fora dos limites */
	/* 35: */ EDEADLK,		/* Foi evitado um \"deadlock\" */
	/* 36: */ ENOLCK,		/* Tabela de \"locks\" cheia */
	/* 37: */ EOLINE,		/* Dispositivo no pronto */
	/* 38: */ EPFULL,		/* FIFO Cheio */
	/* 39: */ ENOTFS,		/* Este dispositivo no contem um sistema de arquivos */
	/* 40: */ EOLDVER,		/* Referenciando biblioteca compartilhada antiga */
	/* 41: */ ENOTMNT,		/* Dispositivo no montado */
	/* 42: */ ETIMEOUT,		/* Tempo de espera esgotado */
	/* 43: */ ENOTREG,		/* No  um arquivo regular */
	/* 44: */ EBADFMT,		/* Formato invlido */
	/* 45: */ ENOSHLIB,		/* Biblioteca compartilhada no carregada */
	/* 46: */ ELOOP,		/* Aninhamento excessivo de elos simblicos */
	/* 63: */ ENAMETOOLONG = 63,	/* Nome excessivamente comprido */
	/* 66: */ ENOTEMPTY = 66,	/* Diretrio no vazio */
	/* 69: */ EDQUOT = 69,		/* Quota de disco excedida */
	/* 70: */ ESTALE, 		/* Referncia no mais vlida a arquivo remoto */
	/* 71: */ EREMOTE, 		/* Nvel excessivo de referncias remotas em um caminho */

	/* 72: */ TBADNET,		/* Rede no inicializada */
	/* 73: */ TUNKNET,		/* Nome/endereo de rede desconhecido */
	/* 74: */ TBADADDR,		/* Erro no formato do endereo */
	/* 75: */ TADDRBUSY,		/* Endereo j sendo utilizado */
	/* 76: */ TNOADDR,		/* No consegui alocar o endereo */
	/* 77: */ TBADOPT,		/* Informaes das opes invlidas */
	/* 78: */ TBADDATA,		/* Informaes do dado invlidas */
	/* 79: */ TNODATA,		/* Ainda no h dados disponveis */
	/* 80: */ TBADSEQ,		/* Nmero de seqncia invlido */
	/* 81: */ TBADQLEN,		/* Tamanho de fila invlido */
	/* 82: */ TBADFLAG,		/* Indicadores invlidos */
	/* 83: */ TNODIS,		/* No h pedido de desconexo abortiva */
	/* 84: */ TNOREL,		/* No h pedido de desconexo ordenada */
	/* 85: */ TBUFOVFLW,		/* Mensagem maior do que a rea disponvel */
	/* 86: */ TOUTSTATE,		/* Estado invlido */
	/* 87: */ TLOOK,		/* Evento ocorrido exige ateno */
	/* 88: */ TFLOW,		/* Controle de fluxo impede transmisso */
	/* 89: */ TNOUDERR,		/* No houve erro no protocolo sem conexo */
	/* 90: */ TNOTSUPPORT,		/* Funo no implementada */
	/* 91: */ TNOROUTE,		/* No h rota para o n destino */
	/* 92: */ TDNSSERVER		/* Erro no servidor de DNS */

}	ERRNO;
