/*
 ****************************************************************
 *								*
 *			isotoatb.c				*
 *								*
 *	Tabela para converso de ISO para ASCII			*
 *								*
 *	Verso	3.0.0, de 15.12.94				*
 *		3.0.0, de 15.12.94				*
 *								*
 *	Mdulo: Ncleo						*
 *		NCLEO do TROPIX para PC			*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  1999 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

/*
 ****************************************************************
 *	A Tabela						*
 ****************************************************************
 */
const char	isotoatb[] =
{

/*	NUL	SOH	STX	ETX	EOT	ENQ	ACK	BE	*/

	0x00,  	0x01,	0x02,	0x03,	0x04,	0x05,	0x06,	0x07,


/*	BS	HT	LF	VT	FF	CR	SO	SI	*/

	0x08,	0x09,	0x0A,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,


/*	DLE	DC1	DC2	DC3	DC4	NAK	SYN	ETB	*/

	0x10,	0x11,	0x12,	0x13,	0x14,	0x15,	0x16,	0x17,


/*	CAN	EM	SUB	ESC	FS	GS	RS	US	*/

	0x18,	0x19,	0x1A,	0x1B,	0x1C,	0x1D,	0x1E,	0x1F,


/*	blank	!	"	#	$	%	&	'	*/

	' ',	'!',	'"',	'#',	'$',	'%',	'&',	'\'',


/*	(	)	*	+	,	-	.	/	*/

	'(',	')',	'*',	'+',	',',	'-',	'.',	'/',


/*	0	1	2	3	4	5	6	7	*/

	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',


/*	8	9	:	;	<	=	>	?	*/

	'8',	'9',	':',	';',	'<',	'=',	'>',	'?',


/*	@	A	B	C	D	E	F	G	*/

	'@',	'A',	'B',	'C',	'D',	'E',	'F',	'G',


/*	H	I	J	K	L	M	N	O	*/

	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',


/*	P	Q	R	S	T	U	V	W	*/

	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',


/*	X	Y	Z	[	\	]	^	_	*/

	'X',	'Y',	'Z',	'[',	'\\',	']',	'^',	'_',


/*	`	a	b	c	d	e	f	g	*/

	'`',	'a',	'b',	'c',	'd',	'e',	'f',	'g',


/*	h	i	j	k	l	m	n	o	*/

	'h',	'i',	'j',	'k',	'l',	'm',	'n',	'o',


/*	p	q	r	s	t	u	v	w	*/

	'p',	'q',	'r',	's',	't',	'u',	'v',	'w',


/*	x	y	z	{	|	}	~	(del)	*/

	'x',	'y',	'z',	'{',	'|',	'}',	'~',	0x7F,


/*	80	81	82	83	84	85	86	87	*/

	'.',	'.',	'.',	'.',	'.',	'.',	'.',	'.',


/*	88	89	8A	8B	8C	8D	8E	8F	*/

	'.',	'.',	'.',	'.',	'.',	'.',	'.',	'.',


/*	90	91	92	93	94	95	96	97	*/

	'.',	'.',	'.',	'.',	'.',	'.',	'.',	'.',


/*	98	99	9A	9B	9C	9D	9E	9F	*/

	'.',	'.',	'.',	'.',	'.',	'.',	'.',	'.',


/*	A0	A1	A2	A3	A4	A5	A6	A7	*/

	'.',	'.',	'.',	'.',	'.',	'.',	'|',	'.',


/*	A8	A9	AA	AB	AC	AD	AE	AF	*/

	'.',	'c',	'a',	'<',	'~',	'-',	'r',	'_',


/*	B0	B1	B2	B3	B4	B5	B6	B7	*/

	'o',	'.',	'2',	'3',	'\'',	'u',	'P',	'.',


/*	B8	B9	BA	BB	BC	BD	BE	BF	*/

	',',	'1',	'o',	'>',	'.',	'.',	'.',	'?',


/*	C0	C1	C2	C3	C4	C5	C6	C7	*/

	'A',	'A',	'A',	'A',	'A',	'A',	'A',	'C',


/*	C8	C9	CA	CB	CC	CD	CE	CF	*/

	'E',	'E',	'E',	'E',	'I',	'I',	'I',	'I',


/*	D0	D1	D2	D3	D4	D5	D6	D7	*/

	'E',	'N',	'O',	'O',	'O',	'O',	'O',	'O',


/*	D8	D9	DA	DB	DC	DD	DE	DF	*/

	'O',	'U',	'U',	'U',	'U',	'Y',	'T',	'S',


/*	E0	E1	E2	E3	E4	E5	E6	E7	*/

	'a',	'a',	'a',	'a',	'a',	'a',	'a',	'c',


/*	E8	E9	EA	EB	EC	ED	EE	EF	*/

	'e',	'e',	'e',	'e',	'i',	'i',	'i',	'i',


/*	F0	F1	F2	F3	F4	F5	F6	F7	*/

	'e',	'n',	'o',	'o',	'o',	'o',	'o',	'o',


/*	F8	F9	FA	FB	FC	FD	FE	FF	*/

	'o',	'u',	'u',	'u',	'u',	'y',	't',	'y'

}	/* end isotoatb */;
